#include <amxmodx>
#include <amxmisc>
#include <engine>
#include <cstrike>
#include <fakemeta_util>
#include <hamsandwich>

/*
	Changelog:
	v1.3:
		- Added a new list of cvars, now you can configure the glow of the weapons (model W_ only)
		- Added more weapons to modify the model:
			- p_thighpack , w_thighpack
			- v_/ p_ / w_ of hegrenade , flashbang , smokegrenade , shield , c4
			- w_backpack
		
	v1.1:
		- Added: Now you can change the model of the weapons.
	
	v1.0:
		- First release
	
	Cambiar Sonidos del knife
	Balas infinitas o Cargadores infinitos
*/

#define CSW_THIGHPACK 	0
#define CSW_SHIELD		2
#define CSW_BACKPACK	32

// Offsets
const OFFSET_LINUX_WEAPONS 			= 4;
const OFFSET_LINUX		 			= 5;
const OFFSET_WEAPON_OWNER			= 41;
const OFFSET_NEXT_PRIMARY_ATTACK	= 46;
const OFFSET_NEXT_SECONDARY_ATTACK 	= 47;
const OFFSET_TIME_WEAPON_IDLE 		= 48;
const OFFSET_IN_RELOAD 				= 54;
const OFFSET_IN_SPECIAL_RELOAD 		= 55;
const OFFSET_NEXT_ATTACK			= 83;

new const g_customization_file_cfg[] = "change_weapons.cfg"
new const g_customization_file_ini[] = "change_weapons.ini"

new const g_weapon_ent_names[][] = { "", "weapon_p228", "", "weapon_scout", "", "weapon_xm1014", "", "weapon_mac10",
"weapon_aug", "", "weapon_elite", "weapon_fiveseven", "weapon_ump45", "weapon_sg550", "weapon_galil", "weapon_famas", "weapon_usp", "weapon_glock18",
"weapon_awp", "weapon_mp5navy", "weapon_m249", "weapon_m3", "weapon_m4a1", "weapon_tmp", "weapon_g3sg1", "", "weapon_deagle", "weapon_sg552",
"weapon_ak47", "weapon_knife", "weapon_p90", "all" };

new const g_weapon_ent_names_all[][] = { "weapon_thighpack", "weapon_p228", "weapon_shield", "weapon_scout", "weapon_hegrenade", "weapon_xm1014", "weapon_c4",
"weapon_mac10", "weapon_aug", "weapon_smokegrenade", "weapon_elite", "weapon_fiveseven", "weapon_ump45", "weapon_sg550", "weapon_galil", "weapon_famas", "weapon_usp",
"weapon_glock18", "weapon_awp", "weapon_mp5navy", "weapon_m249", "weapon_m3", "weapon_m4a1", "weapon_tmp", "weapon_g3sg1", "weapon_flashbang", "weapon_deagle",
"weapon_sg552", "weapon_ak47", "weapon_knife", "weapon_p90", "w_backpack" };

new const g_model_default[][] = { "models/w_thighpack.mdl", "models/w_p228.mdl", "models/w_shield.mdl", "models/w_scout.mdl", "models/w_hegrenade.mdl",
"models/w_xm1014.mdl", "models/w_c4.mdl", "models/w_mac10.mdl", "models/w_aug.mdl", "models/w_smokegrenade.mdl", "models/w_elite.mdl", "models/w_fiveseven.mdl",
"models/w_ump45.mdl", "models/w_sg550.mdl", "models/w_galil.mdl", "models/w_famas.mdl", "models/w_usp.mdl", "models/w_glock18.mdl", "models/w_awp.mdl",
"models/w_mp5navy.mdl", "models/w_m249.mdl", "models/w_m3.mdl", "models/w_m4a1.mdl", "models/w_tmp.mdl", "models/w_g3sg1.mdl", "models/w_flashbang.mdl",
"models/w_deagle.mdl", "models/w_sg552.mdl", "models/w_ak47.mdl", "models/w_knife.mdl", "models/w_p90.mdl", "models/w_backpack.mdl" };

enum()
{
	WEAPON_DAMAGE = 0,
	WEAPON_RECOIL,
	WEAPON_SPEED,
	WEAPON_GLOW,

	MAX_CW
};
new g_cvar_weapon[CSW_P90+3][MAX_CW];

enum()
{
	V_ = 0,
	P_,
	W_,
	
	ALL_MODELS
};
new g_model_weapon[ALL_MODELS][CSW_P90+2][128];

new g_weapon[33];

new g_maxplayers;

#define is_user_valid_connected(%1)	(1 <= %1 <= g_maxplayers && is_user_connected(%1))
public plugin_precache()
{
	fn_load_customization();
}
public plugin_init()
{
	new plugin_name[] = "Change Weapons";
	new plugin_version[] = "v1.31";
	new plugin_author[] = "Kiske";
	
	new i;
	new buffer[32];
	
	register_plugin(plugin_name, plugin_version, plugin_author);
	
	RegisterHam(Ham_TakeDamage, "player", "fw_TakeDamage");
	
	// Register CVARS
	for(i = 0; i < CSW_P90+2; i++)
	{
		if(g_weapon_ent_names[i][0])
		{
			// Recoil , Speed , Change Models
			if(!equali(g_weapon_ent_names[i], "all"))
			{
				// Recoil and Speed
				RegisterHam(Ham_Weapon_PrimaryAttack, g_weapon_ent_names[i], "fw_Weapon_PrimaryAttack_Post", 1);
				
				// Get Weapon and Change Models
				RegisterHam(Ham_Item_Deploy, g_weapon_ent_names[i], "fw_Item_Deploy_Post", 1);
			}
			
			// Remove weapon_ from the names
			replace(g_weapon_ent_names[i], 17, "weapon_", "");
			
			// Damage
			formatex(buffer, charsmax(buffer), "cw_damage_%s", g_weapon_ent_names[i]);
			g_cvar_weapon[i][WEAPON_DAMAGE] = register_cvar(buffer, "off");
			
			// Recoil
			formatex(buffer, charsmax(buffer), "cw_recoil_%s", g_weapon_ent_names[i]);
			g_cvar_weapon[i][WEAPON_RECOIL] = register_cvar(buffer, "off");
			
			// Speed
			formatex(buffer, charsmax(buffer), "cw_speed_%s", g_weapon_ent_names[i]);
			g_cvar_weapon[i][WEAPON_SPEED] = register_cvar(buffer, "off");
			
			// Glow (only W_ model)
			formatex(buffer, charsmax(buffer), "cw_wglow_%s", g_weapon_ent_names[i]);
			g_cvar_weapon[i][WEAPON_GLOW] = register_cvar(buffer, "off");
		}
		
		// Extra Cvars for W_ models glow :)
		g_cvar_weapon[CSW_THIGHPACK][WEAPON_GLOW] = register_cvar("cw_wglow_thighpack", "off");
		g_cvar_weapon[CSW_SHIELD][WEAPON_GLOW] = register_cvar("cw_wglow_shield", "off");
		g_cvar_weapon[CSW_HEGRENADE][WEAPON_GLOW] = register_cvar("cw_wglow_hegrenade", "off");
		g_cvar_weapon[CSW_C4][WEAPON_GLOW] = register_cvar("cw_wglow_c4", "off");
		g_cvar_weapon[CSW_SMOKEGRENADE][WEAPON_GLOW] = register_cvar("cw_wglow_smokegrenade", "off");
		g_cvar_weapon[CSW_FLASHBANG][WEAPON_GLOW] = register_cvar("cw_wglow_flashbang", "off");
		g_cvar_weapon[CSW_BACKPACK][WEAPON_GLOW] = register_cvar("cw_wglow_backpack", "off");
	}
	
	register_forward(FM_SetModel, "fw_SetModel");
	
	g_maxplayers = get_maxplayers();
}

public plugin_cfg()
{
	new cfgdir[32];
	get_configsdir(cfgdir, charsmax(cfgdir));
	
	server_cmd("exec %s/%s", cfgdir, g_customization_file_cfg);
}

public fw_TakeDamage(victim, inflictor, attacker, Float:damage, damage_type) // Damage
{
	if(victim == attacker || !is_user_valid_connected(attacker))
		return HAM_IGNORED;
	
	static dmg_cvar[10];
	static dmg_cvar_k[10];
	static dmg_cvar_temp[10];
	static dmg_cvar_temp_k[10];
	
	get_pcvar_string(g_cvar_weapon[g_weapon[attacker]][WEAPON_DAMAGE], dmg_cvar, charsmax(dmg_cvar));
	get_pcvar_string(g_cvar_weapon[31][WEAPON_DAMAGE], dmg_cvar_temp, charsmax(dmg_cvar_temp));
	
	copy(dmg_cvar_k, charsmax(dmg_cvar_k), dmg_cvar);
	copy(dmg_cvar_temp_k, charsmax(dmg_cvar_temp_k), dmg_cvar_temp);
	
	if(fn_contain_words(dmg_cvar_k) || fn_contain_words(dmg_cvar_temp_k))
	{
		fn_replace_words(dmg_cvar_k, charsmax(dmg_cvar_k));
		fn_replace_words(dmg_cvar_temp_k, charsmax(dmg_cvar_temp_k));
		
		static Float:dmg;
		
		if(equali(dmg_cvar_temp, "off")) dmg = str_to_float(dmg_cvar_k);
		else dmg = str_to_float(dmg_cvar_temp_k);
		
		switch((equali(dmg_cvar_temp, "off")) ? dmg_cvar[0] : dmg_cvar_temp[0])
		{
			case '+':
			{
				if(dmg < 1.00) return HAM_IGNORED;
				damage += dmg;
			}
			case '-':
			{
				if(dmg < 1.00) return HAM_IGNORED;
				damage -= dmg;
			}
			case '*':
			{
				if(dmg == 1.00) return HAM_IGNORED;
				damage *= dmg;
			}
			case '/':
			{
				if(dmg == 0.00) return HAM_IGNORED; // Can't divide by 0
				damage /= dmg;
			}
			case '=':
			{
				if(dmg < 1.00) return HAM_IGNORED;
				damage = dmg;
			}
		}
		
		SetHamParamFloat(4, damage);
	}
	
	return HAM_IGNORED;
}

public fw_Weapon_PrimaryAttack_Post(weapon_ent) // Recoil and Speed
{
	static id;
	id = get_pdata_cbase(weapon_ent, OFFSET_WEAPON_OWNER, OFFSET_LINUX_WEAPONS);
	
	if(!pev_valid(id) || cs_get_weapon_ammo(weapon_ent) < 1)
		return HAM_IGNORED;
	
	// Recoil
	static Float:def_recoil[3];
	entity_get_vector(id, EV_VEC_punchangle, def_recoil);
	
	static recoil_cvar[10];
	static recoil_cvar_k[10];
	static recoil_cvar_temp[10];
	static recoil_cvar_temp_k[10];
	
	get_pcvar_string(g_cvar_weapon[g_weapon[id]][WEAPON_RECOIL], recoil_cvar, charsmax(recoil_cvar));
	get_pcvar_string(g_cvar_weapon[31][WEAPON_RECOIL], recoil_cvar_temp, charsmax(recoil_cvar_temp));
	
	copy(recoil_cvar_k, charsmax(recoil_cvar_k), recoil_cvar);
	copy(recoil_cvar_temp_k, charsmax(recoil_cvar_temp_k), recoil_cvar_temp);
	
	if(fn_contain_words(recoil_cvar_k) || fn_contain_words(recoil_cvar_temp_k))
	{
		fn_replace_words(recoil_cvar_k, charsmax(recoil_cvar_k));
		fn_replace_words(recoil_cvar_temp_k, charsmax(recoil_cvar_temp_k));
		
		static Float:recoil;
		
		if(equali(recoil_cvar_temp, "off")) recoil = str_to_float(recoil_cvar_k);
		else recoil = str_to_float(recoil_cvar_temp_k);
		
		switch((equali(recoil_cvar_temp, "off")) ? recoil_cvar[0] : recoil_cvar_temp[0])
		{
			case '+':
			{
				if(recoil == 0.00) return HAM_IGNORED;
				def_recoil[0] += recoil;
			}
			case '-':
			{
				if(recoil == 0.00) return HAM_IGNORED;
				def_recoil[0] -= recoil;
			}
			case '*':
			{
				if(recoil == 1.00) return HAM_IGNORED;
				def_recoil[0] *= recoil;
			}
			case '/':
			{
				if(recoil == 0.00) return HAM_IGNORED; // Can't divide by 0
				def_recoil[0] /= recoil;
			}
			case '=':
			{
				def_recoil[0] = recoil;
				if(recoil == 0)
					def_recoil[1] = def_recoil[2] = recoil;
			}
		}
		
		entity_set_vector(id, EV_VEC_punchangle, def_recoil);
	}
	
	// Speed
	static Float:def_speed[3];
	def_speed[0] = get_pdata_float(weapon_ent, OFFSET_NEXT_PRIMARY_ATTACK, OFFSET_LINUX_WEAPONS);
	def_speed[1] = get_pdata_float(weapon_ent, OFFSET_NEXT_SECONDARY_ATTACK, OFFSET_LINUX_WEAPONS);
	def_speed[2] = get_pdata_float(weapon_ent, OFFSET_TIME_WEAPON_IDLE, OFFSET_LINUX_WEAPONS);
	
	static speed_cvar[10];
	static speed_cvar_k[10];
	static speed_cvar_temp[10];
	static speed_cvar_temp_k[10];
	
	get_pcvar_string(g_cvar_weapon[g_weapon[id]][WEAPON_SPEED], speed_cvar, charsmax(speed_cvar));
	get_pcvar_string(g_cvar_weapon[31][WEAPON_SPEED], speed_cvar_temp, charsmax(speed_cvar_temp));
	
	copy(speed_cvar_k, charsmax(speed_cvar_k), speed_cvar);
	copy(speed_cvar_temp_k, charsmax(speed_cvar_temp_k), speed_cvar_temp);
	
	if(fn_contain_words(speed_cvar_k) || fn_contain_words(speed_cvar_temp_k))
	{
		fn_replace_words(speed_cvar_k, charsmax(speed_cvar_k));
		fn_replace_words(speed_cvar_temp_k, charsmax(speed_cvar_temp_k));
		
		static Float:speed;
		
		if(equali(speed_cvar_temp, "off")) speed = str_to_float(speed_cvar_k);
		else speed = str_to_float(speed_cvar_temp_k);
		
		switch((equali(speed_cvar_temp, "off")) ? speed_cvar[0] : speed_cvar_temp[0])
		{
			case '+':
			{
				if(speed == 0.00) return HAM_IGNORED;
				def_speed[0] += speed;
				def_speed[1] += speed;
				def_speed[2] += speed;
			}
			case '-':
			{
				if(speed == 0.00) return HAM_IGNORED;
				def_speed[0] -= speed;
				def_speed[1] -= speed;
				def_speed[2] -= speed;
			}
			case '*':
			{
				if(speed == 1.00) return HAM_IGNORED;
				def_speed[0] *= speed;
				def_speed[1] *= speed;
				def_speed[2] *= speed;
			}
			case '/':
			{
				if(speed == 0.00) return HAM_IGNORED; // Can't divide by 0
				def_speed[0] /= speed;
				def_speed[1] /= speed;
				def_speed[2] /= speed;
			}
			case '=': def_speed[0] = def_speed[1] = def_speed[2] = speed;
		}
		
		set_pdata_float(weapon_ent, OFFSET_NEXT_PRIMARY_ATTACK, def_speed[0], OFFSET_LINUX_WEAPONS)
		set_pdata_float(weapon_ent, OFFSET_NEXT_SECONDARY_ATTACK, def_speed[1], OFFSET_LINUX_WEAPONS)
		set_pdata_float(weapon_ent, OFFSET_TIME_WEAPON_IDLE, def_speed[2], OFFSET_LINUX_WEAPONS)
	}
	
	return HAM_IGNORED;
}

public fw_Item_Deploy_Post(weapon_ent)
{
	static id;
	id = get_pdata_cbase(weapon_ent, OFFSET_WEAPON_OWNER, OFFSET_LINUX_WEAPONS);
	
	if(!pev_valid(id))
		return;
	
	static weaponid;
	weaponid = cs_get_weapon_id(weapon_ent);
	
	g_weapon[id] = weaponid;
	
	// Replace Weapon Models
	fn_replace_weapon_models(id, weaponid);
}

public fw_SetModel(entity, const model[])
{
	if(strlen(model) < 8 || model[7] != 'w' || model[8] != '_')
		return FMRES_IGNORED;
	
	static classname[10];
	static color_all[21];
	
	entity_get_string(entity, EV_SZ_classname, classname, charsmax(classname));
	get_pcvar_string(g_cvar_weapon[31][WEAPON_GLOW], color_all, charsmax(color_all));
	
	if(equal(classname, "weaponbox") ||
	equali(model, "models/w_shield.mdl") ||
	equali(model, "models/w_thighpack.mdl") ||
	equali(model, "models/w_c4.mdl") ||
	equali(model, "models/w_backpacks.mdl")) // sory for that :(
	{
		static i;
		static color[21];
		static p_rgb[3][4];
		static i_rgb[3];
		
		for(i = 0; i < CSW_P90+2; i++)
		{
			if(equali(model, g_model_default[i]))
			{
				get_pcvar_string(g_cvar_weapon[i][WEAPON_GLOW], color, charsmax(color));
				if(!equali(color, "off") || !equali(color_all, "off"))
				{
					if(equali(color_all, "off")) parse(color, p_rgb[0], charsmax(p_rgb[]), p_rgb[1], charsmax(p_rgb[]), p_rgb[2], charsmax(p_rgb[]));
					else parse(color_all, p_rgb[0], charsmax(p_rgb[]), p_rgb[1], charsmax(p_rgb[]), p_rgb[2], charsmax(p_rgb[]));
					
					i_rgb[0] = clamp(str_to_num(p_rgb[0]), 0, 255);
					i_rgb[1] = clamp(str_to_num(p_rgb[1]), 0, 255);
					i_rgb[2] = clamp(str_to_num(p_rgb[2]), 0, 255);
					
					fm_set_rendering(entity, kRenderFxGlowShell, i_rgb[0], i_rgb[1], i_rgb[2], kRenderNormal, 16);
				}
				
				if(g_model_weapon[W_][i][0])
				{
					entity_set_model(entity, g_model_weapon[W_][i]);
					return FMRES_SUPERCEDE;
				}
			}
		}
		
		return FMRES_IGNORED;
	}
	
	static Float:dmg_time;
	dmg_time = entity_get_float(entity, EV_FL_dmgtime);
	
	if(dmg_time == 0.0)
		return FMRES_IGNORED;
	
	static pg_rgb[3][3][4];
	static ig_rgb[3][3];
	if(equali(color_all, "off"))
	{
		static color_grenades[3][21];
		
		get_pcvar_string(g_cvar_weapon[CSW_HEGRENADE][WEAPON_GLOW], color_grenades[0], charsmax(color_grenades[]));
		get_pcvar_string(g_cvar_weapon[CSW_FLASHBANG][WEAPON_GLOW], color_grenades[1], charsmax(color_grenades[]));
		get_pcvar_string(g_cvar_weapon[CSW_SMOKEGRENADE][WEAPON_GLOW], color_grenades[2], charsmax(color_grenades[]));
		
		if(!equali(color_grenades[0], "off"))
		{
			parse(color_grenades[0], pg_rgb[0][0], charsmax(pg_rgb[][]), pg_rgb[1][0], charsmax(pg_rgb[][]), pg_rgb[2][0], charsmax(pg_rgb[][]));
			
			ig_rgb[0][0] = clamp(str_to_num(pg_rgb[0][0]), 0, 255);
			ig_rgb[1][0] = clamp(str_to_num(pg_rgb[1][0]), 0, 255);
			ig_rgb[2][0] = clamp(str_to_num(pg_rgb[2][0]), 0, 255);
		}
		if(!equali(color_grenades[1], "off"))
		{
			parse(color_grenades[1], pg_rgb[0][1], charsmax(pg_rgb[][]), pg_rgb[1][1], charsmax(pg_rgb[][]), pg_rgb[2][1], charsmax(pg_rgb[][]));
			
			ig_rgb[0][1] = clamp(str_to_num(pg_rgb[0][1]), 0, 255);
			ig_rgb[1][1] = clamp(str_to_num(pg_rgb[1][1]), 0, 255);
			ig_rgb[2][1] = clamp(str_to_num(pg_rgb[2][1]), 0, 255);
		}
		if(!equali(color_grenades[2], "off"))
		{
			parse(color_grenades[2], pg_rgb[0][2], charsmax(pg_rgb[][]), pg_rgb[1][2], charsmax(pg_rgb[][]), pg_rgb[2][2], charsmax(pg_rgb[][]));
			
			ig_rgb[0][2] = clamp(str_to_num(pg_rgb[0][2]), 0, 255);
			ig_rgb[1][2] = clamp(str_to_num(pg_rgb[1][2]), 0, 255);
			ig_rgb[2][2] = clamp(str_to_num(pg_rgb[2][2]), 0, 255);
		}
	}
	else
	{
		parse(color_all, pg_rgb[0][0], charsmax(pg_rgb[][]), pg_rgb[1][0], charsmax(pg_rgb[][]), pg_rgb[2][0], charsmax(pg_rgb[][]));
		
		ig_rgb[0][0] = ig_rgb[0][1] = ig_rgb[0][2] = clamp(str_to_num(pg_rgb[0][0]), 0, 255);
		ig_rgb[1][0] = ig_rgb[1][1] = ig_rgb[1][2] = clamp(str_to_num(pg_rgb[1][0]), 0, 255);
		ig_rgb[2][0] = ig_rgb[2][1] = ig_rgb[2][2] = clamp(str_to_num(pg_rgb[2][0]), 0, 255);
	}
	
	if(model[9] == 'h' && model[10] == 'e') // HE Grenade
	{
		// Give it a glow
		fm_set_rendering(entity, kRenderFxGlowShell, ig_rgb[0][0], ig_rgb[1][0], ig_rgb[2][0], kRenderNormal, 16);
		
		// Change Model
		if(g_model_weapon[W_][CSW_HEGRENADE][0])
		{
			entity_set_model(entity, g_model_weapon[W_][CSW_HEGRENADE]);
			return FMRES_SUPERCEDE;
		}
	}
	else if(model[9] == 'f' && model[10] == 'l') // Flash Grenade
	{
		// Give it a glow
		fm_set_rendering(entity, kRenderFxGlowShell, ig_rgb[0][1], ig_rgb[1][1], ig_rgb[2][1], kRenderNormal, 16);
		
		// Change Model
		if(g_model_weapon[W_][CSW_FLASHBANG][0])
		{
			entity_set_model(entity, g_model_weapon[W_][CSW_FLASHBANG]);
			return FMRES_SUPERCEDE;
		}
	}
	else if(model[9] == 's' && model[10] == 'm') // Smoke Grenade
	{
		// Give it a glow
		fm_set_rendering(entity, kRenderFxGlowShell, ig_rgb[0][2], ig_rgb[1][2], ig_rgb[2][2], kRenderNormal, 16);
		
		// Change Model
		if(g_model_weapon[W_][CSW_SMOKEGRENADE][0])
		{
			entity_set_model(entity, g_model_weapon[W_][CSW_SMOKEGRENADE]);
			return FMRES_SUPERCEDE;
		}
	}
	
	return FMRES_IGNORED;
}

// Functions
fn_contain_words(const string[])
{
	if(contain(string, "+") != -1 ||
	contain(string, "-") != -1 ||
	contain(string, "*") != -1 ||
	contain(string, "/") != -1 ||
	contain(string, "=") != -1)
		return 1;
	
	return 0;
}
fn_replace_words(string[], len)
{
	replace(string, len, "+", "");
	replace(string, len, "-", "");
	replace(string, len, "*", "");
	replace(string, len, "/", "");
	replace(string, len, "=", "");
}
fn_load_customization()
{
	new path[64];
	get_configsdir(path, charsmax(path));
	
	format(path, charsmax(path), "%s/%s", path, g_customization_file_ini);
	
	if(!file_exists(path)) return;
	
	new linedata[1024];
	new key[64];
	new value[960];
	new weaponname[32];
	new file = fopen(path, "rt");
	new i;
	
	while(file && !feof(file))
	{
		fgets(file, linedata, charsmax(linedata));
		replace(linedata, charsmax(linedata), "^n", "");
		
		if(!linedata[0] || linedata[0] == ';') continue;
		
		strtok(linedata, key, charsmax(key), value, charsmax(value), '=');
		trim(key);
		trim(value);
		
		for(i = 0; i < CSW_P90+2; i++)
		{
			if(g_weapon_ent_names_all[i][0])
			{
				// Remove weapon_ from the names
				copy(weaponname, charsmax(weaponname), g_weapon_ent_names_all[i]);
				
				// Get and precache V_ model
				replace(weaponname, charsmax(weaponname), "weapon_", "V_");
				if(!equali(g_weapon_ent_names_all[i], "weapon_thighpack"))
				{
					if(equali(key, weaponname)) copy(g_model_weapon[V_][i], charsmax(g_model_weapon[][]), value);
					if(g_model_weapon[V_][i][0]) precache_model(value);
				}
				
				// Get and precache P_ model
				replace(weaponname, charsmax(weaponname), "V_", "P_");
				if(equali(key, weaponname)) copy(g_model_weapon[P_][i], charsmax(g_model_weapon[][]), value);
				if(g_model_weapon[P_][i][0]) precache_model(value);
				
				// Get and precache W_ model
				replace(weaponname, charsmax(weaponname), "P_", "W_");
				if(equali(key, weaponname)) copy(g_model_weapon[W_][i], charsmax(g_model_weapon[][]), value);
				if(g_model_weapon[W_][i][0]) precache_model(value);
			}
		}
	}
	
	if(file)
		fclose(file);
}
fn_replace_weapon_models(id, weaponid)
{
	if(!is_user_alive(id))
		return;
	
	if(g_model_weapon[V_][weaponid][0]) entity_set_string(id, EV_SZ_viewmodel, g_model_weapon[V_][weaponid]);
	if(g_model_weapon[P_][weaponid][0]) entity_set_string(id, EV_SZ_weaponmodel, g_model_weapon[P_][weaponid]);
}